// PD_FSUSBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PD_FSUSB.h"
#include "PD_FSUSBDlg.h"
#include <winioctl.h>
#include "..\MPUSBAPI\IoCtls.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPD_FSUSBDlg dialog

CPD_FSUSBDlg::CPD_FSUSBDlg(CWnd* pParent /*=NULL*/) :
	CDialog(CPD_FSUSBDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CPD_FSUSBDlg::~CPD_FSUSBDlg()
{
	if(m_hDevNotify)
		UnregisterDeviceNotification(m_hDevNotify);
}

void CPD_FSUSBDlg::SetStatus(LPCSTR psMsg)
{
	CString sStatus("  ");
	sStatus += psMsg;
	SetDlgItemText(IDC_STATUS, sStatus);
	theApp.ProcessMessages();	// Allow UI to update
}

void CPD_FSUSBDlg::Logln(LPCSTR ps)
{
	if(::IsWindow(m_log))
	{
		CString sLog;
		m_log.GetWindowText(sLog);
		if(sLog.GetLength() > 0)
			sLog += "\r\n";
		sLog += ps;
		m_log.SetWindowText(sLog);
		long l = sLog.GetLength();
		m_log.SetSel(l, l, FALSE);
	}
}

void CPD_FSUSBDlg::ShowWarning(LPCSTR ps)
{
	CString s("WARNING - ");
	s += ps;
	Logln(s);
	theApp.ProcessMessages();	// Allow UI to update
}

void CPD_FSUSBDlg::ShowMessage(LPCSTR ps)
{
	CString s("MESSAGE - ");
	s += ps;
	Logln(s);
	theApp.ProcessMessages();	// Allow UI to update
}

void CPD_FSUSBDlg::ClearLog()
{
	m_log.SetWindowText("");
}

void CPD_FSUSBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TABS, m_tabs);
	DDX_Control(pDX, IDC_LOG, m_log);
}
//+
BEGIN_MESSAGE_MAP(CPD_FSUSBDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CLEAR_LOG, &CPD_FSUSBDlg::OnBnClickedClearLog)
	ON_MESSAGE(WM_DEVICECHANGE, &CPD_FSUSBDlg::OnDeviceChange)
END_MESSAGE_MAP()


// CPD_FSUSBDlg message handlers

BOOL CPD_FSUSBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	DEV_BROADCAST_DEVICEINTERFACE dbi;
	dbi.dbcc_size = sizeof(dbi);
	dbi.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
	dbi.dbcc_classguid = GUID_DEVINTERFACE_MCHPUSB;
	m_hDevNotify = ::RegisterDeviceNotification(m_hWnd, &dbi, DEVICE_NOTIFY_WINDOW_HANDLE);

	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPD_FSUSBDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPD_FSUSBDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPD_FSUSBDlg::OnBnClickedClearLog()
{
	m_log.SetWindowText("");
}

LRESULT CPD_FSUSBDlg::OnDeviceChange(WPARAM wParam, LPARAM lParam)
{
	m_tabs.OnDeviceChange((UINT)wParam, (DEV_BROADCAST_HDR*)lParam);
	return 0;
}

BOOL CPD_FSUSBDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
    if (pMsg->message == WM_KEYDOWN && ( pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE) )
    {
		// we don't want escape or return to close the dialog
		return TRUE;
    }

	return CDialog::PreTranslateMessage(pMsg);
}
